Index: issm/trunk/src/m/classes/SMBgradientscomponents.py
===================================================================
--- issm/trunk/src/m/classes/SMBgradientscomponents.py	(revision 23394)
+++ issm/trunk/src/m/classes/SMBgradientscomponents.py	(revision 23394)
@@ -0,0 +1,78 @@
+from fielddisplay import fielddisplay
+from checkfield import checkfield
+from WriteData import WriteData
+from project3d import project3d
+
+class SMBgradientscomponents(object):
+	"""
+	SMBgradients Class definition
+
+	   Usage:
+	      SMBgradients=SMBgradientscomponents();
+	For now it has accumulation, runoff ans retention which could be aither refreezing and/or evaporation
+	"""
+
+	def __init__(self): # {{{
+		self.accuref					 = float('NaN')
+		self.accualti					 = float('NaN')
+		self.accugrad					 = float('NaN')
+		self.runoffref				 = float('NaN')
+		self.runoffalti				 = float('NaN')
+		self.runoffgrad				 = float('NaN')
+		self.requested_outputs = ['default']
+		#}}}
+	def __repr__(self): # {{{
+		string="   surface forcings parameters:"
+		string="%s\n%s"%(string,fielddisplay(self,'accuref',' reference value of the accumulation'))
+		string="%s\n%s"%(string,fielddisplay(self,'accualti',' Altitude at which the accumulation is equal to the reference value'))
+		string="%s\n%s"%(string,fielddisplay(self,'accugrad',' Gradient of the variation of the accumulation (0 for uniform accumulation)'))
+		string="%s\n%s"%(string,fielddisplay(self,'runoffref',' reference value of the runoff m w.e. y-1 (temperature times ddf)'))
+		string="%s\n%s"%(string,fielddisplay(self,'runoffalti',' Altitude at which the runoff is equal to the reference value'))
+		string="%s\n%s"%(string,fielddisplay(self,'runoffgrad',' Gradient of the variation of the runoff (0 for uniform runoff) m w.e. m-1 y-1 (lpase rate times ddf)'))
+		string="%s\n%s"%(string,fielddisplay(self,'requested_outputs','additional outputs requested'))
+
+		return string
+		#}}}
+	def extrude(self,md): # {{{
+		#Nothing for now
+		return self
+	#}}}
+	def defaultoutputs(self,md): # {{{
+		return ['SmbMassBalance','SmbRunoff']
+	#}}}
+	def initialize(self,md): # {{{
+		#Nothing for now
+		return self
+	#}}}
+	def checkconsistency(self,md,solution,analyses):    # {{{
+		if 'MasstransportAnalysis' in analyses:
+			md = checkfield(md,'fieldname','smb.accuref','singletimeseries',1,'NaN',1,'Inf',1)
+			md = checkfield(md,'fieldname','smb.accualti','numel',[1],'NaN',1,'Inf',1)
+			md = checkfield(md,'fieldname','smb.accugrad','numel',[1],'NaN',1,'Inf',1)
+			md = checkfield(md,'fieldname','smb.runoffref','singletimeseries',1,'NaN',1,'Inf',1)
+			md = checkfield(md,'fieldname','smb.runoffalti','numel',[1],'NaN',1,'Inf',1)
+			md = checkfield(md,'fieldname','smb.runoffgrad','numel',[1],'NaN',1,'Inf',1)
+		md = checkfield(md,'fieldname','masstransport.requested_outputs','stringrow',1)
+		return md
+	# }}}
+	def marshall(self,prefix,md,fid):    # {{{
+
+		yts=md.constants.yts
+
+		WriteData(fid,prefix,'name','md.smb.model','data',11,'format','Integer')
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','accuref','format','DoubleMat','mattype',1,'timeserieslength',2,'yts',md.constants.yts,'scale',1./md.constants.yts)
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','accualti','format','Double')
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','accugrad','format','Double','scale',1./md.constants.yts)
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','runoffref','format','DoubleMat','mattype',1,'timeserieslength',2,'yts',md.constants.yts,'scale',1./md.constants.yts)
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','runoffalti','format','Double')
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','runoffgrad','format','Double','scale',1./md.constants.yts)
+
+		#process requested outputs
+		outputs = self.requested_outputs
+		indices = [i for i, x in enumerate(outputs) if x == 'default']
+		if len(indices) > 0:
+			outputscopy=outputs[0:max(0,indices[0]-1)]+self.defaultoutputs(md)+outputs[indices[0]+1:]
+			outputs    =outputscopy
+		WriteData(fid,prefix,'data',outputs,'name','md.smb.requested_outputs','format','StringArray')
+
+	# }}}
Index: issm/trunk/src/m/classes/SMBpddSicopolis.m
===================================================================
--- issm/trunk/src/m/classes/SMBpddSicopolis.m	(revision 23394)
+++ issm/trunk/src/m/classes/SMBpddSicopolis.m	(revision 23394)
@@ -0,0 +1,133 @@
+%SMBpddSicopolis Class definition
+%
+%   Usage:
+%      SMBpddSicopolis=SMBpddSicopolis();
+
+classdef SMBpddSicopolis
+	properties (SetAccess=public) 
+		precipitation					= NaN;
+		monthlytemperatures			= NaN;
+		temperature_anomaly			= NaN;
+		precipitation_anomaly		= NaN;
+		smb_corr							= NaN;
+		desfac							= 0;
+		s0p								= NaN;
+		s0t								= NaN;
+		rlaps								= 0;
+		isfirnwarming					= 0;
+		requested_outputs				= {};
+	end
+	methods
+		function self = SMBpddSicopolis(varargin) % {{{
+			switch nargin
+				case 0
+					self=setdefaultparameters(self);
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+		function self = extrude(self,md) % {{{
+			self.precipitation=project3d(md,'vector',self.precipitation,'type','node');
+			self.monthlytemperatures=project3d(md,'vector',self.monthlytemperatures,'type','node');
+			self.temperature_anomaly=project3d(md,'vector',self.temperature_anomaly,'type','node');
+			self.precipitation_anomaly=project3d(md,'vector',self.precipitation_anomaly,'type','node');
+			self.smb_corr=project3d(md,'vector',self.smb_corr,'type','node');
+			self.s0p=project3d(md,'vector',self.s0p,'type','node');
+			self.s0t=project3d(md,'vector',self.s0t,'type','node');
+
+		end % }}}
+		function list = defaultoutputs(self,md) % {{{
+			list = {''};
+		end % }}}
+		function self = initialize(self,md) % {{{
+                    
+			if isnan(self.s0p),
+				self.s0p=zeros(md.mesh.numberofvertices,1);
+				disp('      no SMBpddSicopolis.s0p specified: values set as zero');
+			end
+			if isnan(self.s0t),
+				self.s0t=zeros(md.mesh.numberofvertices,1);
+				disp('      no SMBpddSicopolis.s0t specified: values set as zero');
+			end
+			if isnan(self.temperature_anomaly),
+				self.temperature_anomaly=zeros(md.mesh.numberofvertices,1);
+				disp('      no SMBpddSicopolis.temperature_anomaly specified: values set as zero');
+			end
+			if isnan(self.precipitation_anomaly),
+				self.precipitation_anomaly=ones(md.mesh.numberofvertices,1);
+				disp('      no SMBpddSicopolis.precipitation_anomaly specified: values set as ones');
+			end
+			if isnan(self.smb_corr),
+				self.smb_corr=zeros(md.mesh.numberofvertices,1);
+				disp('      no SMBpddSicopolis.smb_corr specified: values set as zero');
+			end
+
+		end % }}}
+		function self = setdefaultparameters(self) % {{{
+
+		  self.isfirnwarming		= 1;
+		  self.desfac				= -log(2.0)/1000;
+		  self.rlaps				= 7.4;
+                  
+		end % }}}
+		function md = checkconsistency(self,md,solution,analyses) % {{{
+
+			if (strcmp(solution,'TransientSolution') & md.transient.issmb == 0), return; end
+
+			if ismember('MasstransportAnalysis',analyses),
+				md = checkfield(md,'fieldname','smb.desfac','<=',1,'numel',1);
+				md = checkfield(md,'fieldname','smb.s0p','>=',0,'NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1]);
+				md = checkfield(md,'fieldname','smb.s0t','>=',0,'NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1]);
+				md = checkfield(md,'fieldname','smb.rlaps','>=',0,'numel',1);
+				md = checkfield(md,'fieldname','smb.monthlytemperatures','timeseries',1,'NaN',1,'Inf',1,'size',[md.mesh.numberofvertices+1 12]);
+				md = checkfield(md,'fieldname','smb.precipitation','timeseries',1,'NaN',1,'Inf',1,'size',[md.mesh.numberofvertices+1 12]);
+			end
+			md = checkfield(md,'fieldname','smb.requested_outputs','stringrow',1);
+			
+		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('   surface forcings parameters:'));
+
+			disp(sprintf('\n   SICOPOLIS PDD scheme (Calov & Greve, 2005) :'));
+			fielddisplay(self,'monthlytemperatures','monthly surface temperatures [K]');
+			fielddisplay(self,'precipitation','monthly surface precipitation [m/yr water eq]');
+			fielddisplay(self,'temperature_anomaly','anomaly to monthly reference temperature (additive; [K])');
+			fielddisplay(self,'precipitation_anomaly','anomaly to monthly precipitation (multiplicative, e.g. q=q0*exp(0.070458*DeltaT) after Huybrechts (2002)); [no unit])');
+			fielddisplay(self,'smb_corr','correction of smb after PDD call [m/a]');
+			fielddisplay(self,'s0p','should be set to elevation from precip source (between 0 and a few 1000s m, default is 0) [m]');
+			fielddisplay(self,'s0t','should be set to elevation from temperature source (between 0 and a few 1000s m, default is 0) [m]');
+			fielddisplay(self,'rlaps','present day lapse rate (default is 7.4 degree/km)');
+			fielddisplay(self,'desfac','desertification elevation factor (default is -log(2.0)/1000)');
+			fielddisplay(self,'isfirnwarming','is firnwarming (Reeh 1991) activated (0 or 1, default is 1)');
+			fielddisplay(self,'requested_outputs','additional outputs requested (TemperaturePDD, SmbAccumulation, SmbMelt)');
+		end % }}}
+		function marshall(self,prefix,md,fid) % {{{
+
+			yts=md.constants.yts;
+
+			WriteData(fid,prefix,'name','md.smb.model','data',10,'format','Integer');
+
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','isfirnwarming','format','Boolean');
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','desfac','format','Double');
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','s0p','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','s0t','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','rlaps','format','Double');
+
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','monthlytemperatures','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','precipitation','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','temperature_anomaly','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','precipitation_anomaly','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','smb_corr','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+
+			%process requested outputs
+			outputs = self.requested_outputs;
+			pos  = find(ismember(outputs,'default'));
+			if ~isempty(pos),
+				outputs(pos) = [];                         %remove 'default' from outputs
+				outputs      = [outputs defaultoutputs(self,md)]; %add defaults
+			end
+			WriteData(fid,prefix,'data',outputs,'name','md.smb.requested_outputs','format','StringArray');
+
+		end % }}}
+	end
+end
Index: issm/trunk/src/m/classes/SMBpddSicopolis.py
===================================================================
--- issm/trunk/src/m/classes/SMBpddSicopolis.py	(revision 23394)
+++ issm/trunk/src/m/classes/SMBpddSicopolis.py	(revision 23394)
@@ -0,0 +1,153 @@
+import numpy as np
+from fielddisplay import fielddisplay
+from checkfield import checkfield
+from WriteData import WriteData
+from project3d import project3d
+from MatlabFuncs import *
+from helpers import *
+
+class SMBpddSicopolis(object):
+	"""
+	SMBpddSicopolis Class definition
+
+	Usage:
+		SMBpddSicopolis=SMBpddSicopolis()
+"""
+
+	def __init__(self): # {{{
+		self.precipitation			= float('NaN')
+		self.monthlytemperatures		= float('NaN')
+		self.temperature_anomaly		= float('NaN')
+		self.precipitation_anomaly		= float('NaN')
+		self.smb_corr				= float('NaN')
+		self.desfac				= 0
+		self.s0p				= float('NaN')
+		self.s0t				= float('NaN')
+		self.rlaps				= 0
+		self.isfirnwarming			= 0
+		self.requested_outputs			= []
+		
+		self.setdefaultparameters()
+	# }}}
+	
+	@staticmethod
+	def SMBpddSicopolis(*args): # {{{
+		nargin = len(args)
+
+		if nargin == 0:
+			return SMBpddSicopolis()
+		else:
+			raise RuntimeError('SMBpddSicopolis: constructor not supported')
+	# }}}
+
+	def extrude(self,md): # {{{
+		self.precipitation = project3d(md,'vector',self.precipitation,'type','node')
+		self.monthlytemperatures = project3d(md,'vector',self.monthlytemperatures,'type','node')
+		self.temperature_anomaly = project3d(md,'vector',self.temperature_anomaly,'type','node')
+		self.precipitation_anomaly = project3d(md,'vector',self.precipitation_anomaly,'type','node')
+		self.smb_corr = project3d(md,'vector',self.smb_corr,'type','node')
+		self.s0p = project3d(md,'vector',self.s0p,'type','node')
+		self.s0t = project3d(md,'vector',self.s0t,'type','node')
+	# }}}
+
+	def defaultoutputs(self,md): # {{{
+		l = ['']
+		return l
+	# }}}
+
+	def initialize(self,md): # {{{
+            
+		if np.isnan(self.s0p):
+			self.s0p = np.zeros((md.mesh.numberofvertices,))
+			print '      no SMBpddSicopolis.s0p specified: values set as zero'
+		
+		if np.isnan(self.s0t):
+			self.s0t = np.zeros((md.mesh.numberofvertices,))
+			print '      no SMBpddSicopolis.s0t specified: values set as zero'
+		
+		if np.isnan(self.temperature_anomaly):
+			self.temperature_anomaly = np.zeros((md.mesh.numberofvertices,))
+			print '      no SMBpddSicopolis.temperature_anomaly specified: values set as zero'
+		
+		if np.isnan(self.precipitation_anomaly):
+			self.precipitation_anomaly = np.ones((md.mesh.numberofvertices,))
+			print '      no SMBpddSicopolis.precipitation_anomaly specified: values set as ones'
+		
+		if np.isnan(self.smb_corr):
+			self.smb_corr = np.zeros((md.mesh.numberofvertices,))
+			print '      no SMBpddSicopolis.smb_corr specified: values set as zero'
+	# }}}
+
+	def setdefaultparameters(self): # {{{
+
+	  self.isfirnwarming	= 1
+	  self.desfac		= -np.log(2.0)/1000
+	  self.rlaps		= 7.4
+          
+	# }}}
+
+	def checkconsistency(self,md,solution,analyses): # {{{
+
+		if (strcmp(solution,'TransientSolution') and md.transient.issmb == 0):
+			return 
+
+		if 'MasstransportAnalysis' in analyses:
+			md = checkfield(md,'fieldname','smb.desfac','<=',1,'numel',1)
+			md = checkfield(md,'fieldname','smb.s0p','>=',0,'NaN',1,'Inf',1,'size',[md.mesh.numberofvertices,1])
+			md = checkfield(md,'fieldname','smb.s0t','>=',0,'NaN',1,'Inf',1,'size',[md.mesh.numberofvertices,1])
+			md = checkfield(md,'fieldname','smb.rlaps','>=',0,'numel',1)
+			md = checkfield(md,'fieldname','smb.monthlytemperatures','timeseries',1,'NaN',1,'Inf',1,'size',[md.mesh.numberofvertices+1,12])
+			md = checkfield(md,'fieldname','smb.precipitation','timeseries',1,'NaN',1,'Inf',1,'size',[md.mesh.numberofvertices+1,12])
+		
+		md = checkfield(md,'fieldname','smb.requested_outputs','stringrow',1)
+		
+		return md
+	# }}}
+
+	def __repr__(self): # {{{
+		string = '   surface forcings parameters:'
+		string += '\n   SICOPOLIS PDD scheme (Calov & Greve, 2005) :'
+
+		string = "%s\n%s"%(string,fielddisplay(self,'monthlytemperatures','monthly surface temperatures [K]'))
+		string = "%s\n%s"%(string,fielddisplay(self,'precipitation','monthly surface precipitation [m/yr water eq]'))
+		string = "%s\n%s"%(string,fielddisplay(self,'temperature_anomaly','anomaly to monthly reference temperature (additive [K])'))
+		string = "%s\n%s"%(string,fielddisplay(self,'precipitation_anomaly','anomaly to monthly precipitation (multiplicative, e.g. q=q0*exp(0.070458*DeltaT) after Huybrechts (2002)) [no unit])'))
+		string = "%s\n%s"%(string,fielddisplay(self,'smb_corr','correction of smb after PDD call [m/a]'))
+		string = "%s\n%s"%(string,fielddisplay(self,'s0p','should be set to elevation from precip source (between 0 and a few 1000s m, default is 0) [m]'))
+		string = "%s\n%s"%(string,fielddisplay(self,'s0t','should be set to elevation from temperature source (between 0 and a few 1000s m, default is 0) [m]'))
+		string = "%s\n%s"%(string,fielddisplay(self,'rlaps','present day lapse rate (default is 7.4 degree/km)'))
+		string = "%s\n%s"%(string,fielddisplay(self,'desfac','desertification elevation factor (default is -log(2.0)/1000)'))
+		string = "%s\n%s"%(string,fielddisplay(self,'isfirnwarming','is firnwarming (Reeh 1991) activated (0 or 1, default is 1)'))
+		string = "%s\n%s"%(string,fielddisplay(self,'requested_outputs','additional outputs requested (TemperaturePDD, SmbAccumulation, SmbMelt)'))
+	# }}}
+
+	def marshall(self,prefix,md,fid): # {{{
+
+		yts=md.constants.yts
+
+		WriteData(fid,prefix,'name','md.smb.model','data',10,'format','Integer')
+
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','isfirnwarming','format','Boolean')
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','desfac','format','Double')
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','s0p','format','DoubleMat','mattype',1)
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','s0t','format','DoubleMat','mattype',1)
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','rlaps','format','Double')
+
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','monthlytemperatures','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','precipitation','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','temperature_anomaly','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','precipitation_anomaly','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
+		WriteData(fid,prefix,'object',self,'class','smb','fieldname','smb_corr','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
+
+		#process requested outputs
+		outputs = self.requested_outputs
+		pos  = np.where('default' in outputs)
+		if not isempty(pos):
+			outputs[pos] = []                         #remove 'default' from outputs
+			outputs      = [outputs,defaultoutputs(self,md)] #add defaults
+		
+		WriteData(fid,prefix,'data',outputs,'name','md.smb.requested_outputs','format','StringArray')
+
+	# }}}
+	
+
Index: issm/trunk/src/m/classes/autodiff.js
===================================================================
--- issm/trunk/src/m/classes/autodiff.js	(revision 23389)
+++ issm/trunk/src/m/classes/autodiff.js	(revision 23394)
@@ -14,4 +14,5 @@
 		this.gcTriggerRatio=2.0;
 		this.gcTriggerMaxSize=65536;
+		this.tapeAlloc    = 15000000;
 
 	}// }}}
@@ -29,4 +30,5 @@
 		fielddisplay(this,'gcTriggerRatio','free location block sorting/consolidation triggered if the ratio between allocated and used locations exceeds gcTriggerRatio');
 		fielddisplay(this,'gcTriggerMaxSize','free location block sorting/consolidation triggered if the allocated locations exceed gcTriggerMaxSize');
+		fielddisplay(this,'tapeAlloc','Iteration count of a priori memory allocation of the AD tape');
 
 	}// }}}
@@ -49,4 +51,5 @@
 			checkfield(md,'fieldname','autodiff.gcTriggerRatio','>=',0);
 			checkfield(md,'fieldname','autodiff.gcTriggerMaxSize','>=',65536);
+			checkfield(md,'fieldname','autodiff.tapeAlloc','>=',0);
 
 			//go through our dependents and independents and check consistency: 
@@ -79,4 +82,5 @@
 			WriteData(fid,prefix,'object',this,'fieldname','gcTriggerRatio','format','Double');
 			WriteData(fid,prefix,'object',this,'fieldname','gcTriggerMaxSize','format','Double');
+			WriteData(fid,prefix,'object',this,'fieldname','tapeAlloc','format','Integer');
 			//}}}
 			//process dependent variables {{{
@@ -216,4 +220,5 @@
 			this.gcTriggerRatio=NullFix(this.gcTriggerRatio,NaN);
 			this.gcTriggerMaxSize=NullFix(this.gcTriggerMaxSize,NaN);
+			this.tapeAlloc=NullFix(this.tapeAlloc,NaN);
 		}//}}}
 	//properties 
@@ -229,4 +234,5 @@
 	this.gcTriggerRatio = NaN;
 	this.gcTriggerMaxSize = NaN;
+	this.tapeAlloc = NaN;
 
 	this.setdefaultparameters();
Index: issm/trunk/src/m/classes/autodiff.m
===================================================================
--- issm/trunk/src/m/classes/autodiff.m	(revision 23389)
+++ issm/trunk/src/m/classes/autodiff.m	(revision 23394)
@@ -17,4 +17,5 @@
 		gcTriggerRatio = NaN;
 		gcTriggerMaxSize = NaN;
+		tapeAlloc = NaN;
 		end
 		%}}}
@@ -35,4 +36,5 @@
 		self.gcTriggerRatio=2.0;
 		self.gcTriggerMaxSize=65536;
+		self.tapeAlloc    = 15000000;
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
@@ -51,4 +53,5 @@
 			md = checkfield(md,'fieldname','autodiff.gcTriggerRatio','>=',0);
 			md = checkfield(md,'fieldname','autodiff.gcTriggerMaxSize','>=',65536);
+			md = checkfield(md,'fieldname','autodiff.tapeAlloc','>=',0);
 
 			%go through our dependents and independents and check consistency: 
@@ -75,4 +78,5 @@
 			fielddisplay(self,'gcTriggerRatio','free location block sorting/consolidation triggered if the ratio between allocated and used locations exceeds gcTriggerRatio');
 			fielddisplay(self,'gcTriggerMaxSize','free location block sorting/consolidation triggered if the allocated locations exceed gcTriggerMaxSize');
+			fielddisplay(self,'tapeAlloc','Iteration count of a priori memory allocation of the AD tape');
 		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
@@ -95,4 +99,5 @@
 			WriteData(fid,prefix,'object',self,'fieldname','gcTriggerRatio','format','Double');
 			WriteData(fid,prefix,'object',self,'fieldname','gcTriggerMaxSize','format','Double');
+			WriteData(fid,prefix,'object',self,'fieldname','tapeAlloc','format','Integer');
 			%}}}
 			%process dependent variables {{{
Index: issm/trunk/src/m/classes/autodiff.py
===================================================================
--- issm/trunk/src/m/classes/autodiff.py	(revision 23389)
+++ issm/trunk/src/m/classes/autodiff.py	(revision 23394)
@@ -25,4 +25,5 @@
 		self.gcTriggerMaxSize     = float('NaN')
 		self.gcTriggerRatio     = float('NaN')
+                self.tapeAlloc = float('NaN')
 		if not len(args):
 			self.setdefaultparameters()
@@ -43,4 +44,5 @@
 		s+="%s\n" % fielddisplay(self,'gcTriggerRatio',"free location block sorting/consolidation triggered if the ratio between allocated and used locations exceeds gcTriggerRatio")
 		s+="%s\n" % fielddisplay(self,'gcTriggerMaxSize',"free location block sorting/consolidation triggered if the allocated locations exceed gcTriggerMaxSize)")
+                s+="%s\n" % fielddisplay(self,'tapeAlloc','Iteration count of a priori memory allocation of the AD tape');
 
 		return s
@@ -54,4 +56,5 @@
 		self.gcTriggerRatio=2.0
 		self.gcTriggerMaxSize=65536
+                self.tapeAlloc    = 15000000;
 		return self
 	# }}}
@@ -68,4 +71,5 @@
 		md = checkfield(md,'fieldname','autodiff.gcTriggerRatio','>=',2.0)
 		md = checkfield(md,'fieldname','autodiff.gcTriggerMaxSize','>=',65536)
+                md = checkfield(md,'fieldname','autodiff.tapeAlloc','>=',0);
 
 		#Driver value:
@@ -97,5 +101,6 @@
 		WriteData(fid,prefix,'object',self,'fieldname','gcTriggerRatio','format','Double');
 		WriteData(fid,prefix,'object',self,'fieldname','gcTriggerMaxSize','format','Double');
-		#}}}
+                WriteData(fid,prefix,'object',self,'fieldname','tapeAlloc','format','Integer');
+                #}}}
 		#process dependent variables {{{
 		num_dependent_objects=len(self.dependents)
Index: issm/trunk/src/m/classes/cfdragcoeffabsgrad.m
===================================================================
--- issm/trunk/src/m/classes/cfdragcoeffabsgrad.m	(revision 23394)
+++ issm/trunk/src/m/classes/cfdragcoeffabsgrad.m	(revision 23394)
@@ -0,0 +1,78 @@
+%CFDRAGCOEFFABSGRAD class definition
+%
+%   Usage:
+%      cfdragcoeffabsgrad=cfdragcoeffabsgrad();
+%      cfdragcoeffabsgrad=cfdragcoeffabsgrad('name','SurfaceAltimetry',...
+%                    'definitionstring','Outputdefinition1',... 
+%							'model_string','Surface',...
+%                    'weights',ones(md.mesh.numberofvertices,1),...
+%                    'weights_string','WeightsSurfaceObservations');
+%
+%
+
+classdef cfdragcoeffabsgrad
+	properties (SetAccess=public)
+		%cfdragcoeffabsgrad
+		name               = '';
+		definitionstring   = ''; %string that identifies this output definition uniquely, from 'Outputdefinition[1-100]'
+		weights            = NaN; %weight coefficients for every vertex
+		weights_string     = ''; %string to identify this particular set of weights
+		cumulated          = NaN; %do we cumulate cfdragcoeffabsgrad through time?
+	end
+	
+	methods
+		function self = extrude(self,md) % {{{
+			if ~isnan(self.weights)
+				self.weights=project3d(md,'vector',self.weights,'type','node');
+			end
+		end % }}}
+		function self = cfdragcoeffabsgrad(varargin) % {{{
+			if nargin==0,
+				self=setdefaultparameters(self);
+			else
+				%use provided options to change fields
+				options=pairoptions(varargin{:});
+
+				%get name
+				self.name=getfieldvalue(options,'name','');
+				self.definitionstring=getfieldvalue(options,'definitionstring');
+				self.weights=getfieldvalue(options,'weights',NaN);
+				self.weights_string=getfieldvalue(options,'weights_string','');
+
+			end
+		end % }}}
+		function self = setdefaultparameters(self) % {{{
+		end % }}}
+		function md = checkconsistency(self,md,solution,analyses) % {{{
+
+			if ~ischar(self.name),
+				error('cfdragcoeffabsgrad error message: ''name'' field should be a string!');
+			end
+			OutputdefinitionStringArray={};
+			for i=1:100
+				OutputdefinitionStringArray{i}=strcat('Outputdefinition',num2str(i));
+			end
+			md = checkfield(md,'fieldname','self.definitionstring','field',self.definitionstring,'values',OutputdefinitionStringArray);
+
+			md = checkfield(md,'fieldname','self.weights','field',self.weights,'timeseries',1,'NaN',1,'Inf',1);
+
+		end % }}}
+		function md = disp(self) % {{{
+		
+			disp(sprintf('   TimeMisfit:\n'));
+
+			fielddisplay(self,'name','identifier for this cfdragcoeffabsgrad response');
+			fielddisplay(self,'definitionstring','string that identifies this output definition uniquely, from ''Outputdefinition[1-10]''');
+			fielddisplay(self,'weights','weights (at vertices) to apply to the cfdragcoeffabsgrad');
+			fielddisplay(self,'weights_string','string for weights for identification purposes');
+
+		end % }}}
+		function md = marshall(self,prefix,md,fid) % {{{
+
+		WriteData(fid,prefix,'data',self.name,'name','md.cfdragcoeffabsgrad.name','format','String');
+		WriteData(fid,prefix,'data',self.definitionstring,'name','md.cfdragcoeffabsgrad.definitionstring','format','String');
+		WriteData(fid,prefix,'data',self.weights,'name','md.cfdragcoeffabsgrad.weights','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+		WriteData(fid,prefix,'data',self.weights_string,'name','md.cfdragcoeffabsgrad.weights_string','format','String');
+		end % }}}
+	end
+end
